// XUL Object
var winMain, txtImportFile, txtExportFile;
var strRes;

// Added by Higmmer
const BMSVC = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);


var g_errorMesage = "";

function init() {
	strRes = document.getElementById("strRes");

	winMain = document.getElementById("winMain");
	txtImportFile = document.getElementById("txtImportFile");
	txtExportFile = document.getElementById("txtExportFile");
	txtImportFile.style.color = txtExportFile.style.color = "WindowText"; // Added by Higmmer

	document.getElementById( "pageExport" ).canAdvance = false;
	document.getElementById( "pageImport" ).canAdvance = false;
}

function finish() {
	return true;
}

function browseImportFile() {
	var fpicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
	fpicker.init(window, strRes.getString("opml_select_file"), fpicker.modeOpen);
	fpicker.appendFilter(strRes.getString("opml_opml_file") + " (*.xml, *.opml)", "*.xml;*.opml");
	fpicker.appendFilters(fpicker.filterAll);

	var showResult = fpicker.show();
	if(showResult == fpicker.returnOK) {
		txtImportFile.value = fpicker.file.path;
	}
	canAdvanceImport();
}

function browseExportFile() {
	var fpicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
	fpicker.init(window, strRes.getString("opml_select_file"), fpicker.modeSave);
	fpicker.appendFilter(strRes.getString("opml_opml_file") + " (*.xml, *.opml)", "*.xml;*.opml");
	fpicker.appendFilters(fpicker.filterAll);
	fpicker.defaultString = "export.opml";

	var showResult = fpicker.show();
	if(showResult == fpicker.returnOK || showResult == fpicker.returnReplace) {
		txtExportFile.value = fpicker.file.path;
	}
	canAdvanceExport();
}

function checkFilePath(aFilePath, aExistCheck) {
	if(!aFilePath) {
		g_errorMesage = strRes.getString("opml_path_blank");
		return false;
	}

	var tmpFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
	try {
		tmpFile.initWithPath(aFilePath);
		if(aExistCheck) {
			if(!tmpFile.exists()) {
				g_errorMesage = strRes.getString("opml_path_nofile");
				return false;
			}
		}
	} catch(e) {
		g_errorMesage = strRes.getString("opml_path_invalid");
		return false;
	}

	return true;
}

// ********** ********** Import OPML ********** **********

function importOPML() {
	var path = txtImportFile.value;
	if (!checkFilePath(path, true)) {
		reportError(g_errorMesage);
		return false;
	}

	// Removed by Higmmer
	// Actual import process is moved into startImportOPML()

	return true;
}

//----- Added by Higmmer : Start ----->
// ( Mainly moved from old importOPML() to fix "Warning: Unresponsive script" issue
function startImportOPML(){
	var path = txtImportFile.value; // Added by Higmmer
	var uriFixup = Components.classes['@mozilla.org/docshell/urifixup;1'].getService(Components.interfaces.nsIURIFixup);
	var opmlUrl = uriFixup.createFixupURI(path, uriFixup.FIXUP_FLAG_ALLOW_KEYWORD_LOOKUP);

	var httpReq = new XMLHttpRequest();
	try {
		httpReq.open("GET", opmlUrl.spec, false);
		httpReq.overrideMimeType("application/xml");
		httpReq.send(null);
	} catch(e) {
		reportError(strRes.getString("opml_import_fail"));
		cancelImport(); // Added by Higmmer
		return false;
	}

	opmlDoc = httpReq.responseXML;
	if(opmlDoc.documentElement.localName != "opml") {
		reportError(strRes.getString("opml_import_badfile"));
		cancelImport(); // Added by Higmmer
		return false;
	}
	var rssReaderFolderID = _impl.getRootFolderId(); // Modified by Higmmer

	window.opener.UpdateCounter.deactivate(); // Added by Higmmer

	var folderName = "OPML Import";
	var opmlTitles = opmlDoc.getElementsByTagName("title");
	if(opmlTitles.length > 0) {
		var opmlTitle = CommonFunc.getInnerText(opmlTitles[0]);
		folderName += " - " + opmlTitle;
	}
	var rootFolder = BMSVC.createFolder(rssReaderFolderID, folderName, BMSVC.DEFAULT_INDEX); // Modified by Higmmer (inspired by Sage-Too)

	//----- Modified by Higmmer : Start ----->
	function treeWalkerGenerator() {
		var treeWalker = opmlDoc.createTreeWalker(opmlDoc, NodeFilter.SHOW_ELEMENT, outlineFilter, true);

		while(treeWalker.nextNode()) {
			var cNode = treeWalker.currentNode;
			var pNode = cNode.parentNode;
			var parentFolder = ("_folder" in pNode) ? pNode._folder : rootFolder;
			if(cNode.hasChildNodes()) {
				var title = cNode.getAttribute("title");
				if(!title) title = cNode.getAttribute("text");
				if(!title) title = "folder";
				try {
					cNode._folder = BMSVC.createFolder(parentFolder, title, BMSVC.DEFAULT_INDEX);
				} catch(e) {
					logMessage(e);
				}
			} else {
				createRssItem(cNode, parentFolder);
			}
			yield true;
		}
		yield false;
	}
	function importDone() {
		window.opener.UpdateCounter.activate();
		window.opener.UpdateCounter.update(null, true);
		winMain.canAdvance = true;
		winMain.advance();
	}

	var generator = treeWalkerGenerator();
	window.setTimeout(function(){
		if(generator.next()) {
			window.setTimeout(arguments.callee, 0);
		} else {
			generator.close();
			importDone();
		}
	}, 0);
	//<----- Modified by Higmmer : End -----

	return true;
}
//<----- Added by Higmmer : End -----

function outlineFilter(aNode) {
	if(aNode.localName == "outline") {
		return NodeFilter.FILTER_ACCEPT;
	} else {
		return NodeFilter.FILTER_SKIP;
	}
}

function createRssItem(aOutlineNode, aRssFolder) {
	var type = aOutlineNode.getAttribute("type");
	var title = aOutlineNode.getAttribute("title");
	if(!title) title = aOutlineNode.getAttribute("text");
	//----- Modified by Higmmer : Start (from Sage-Too) ----->
	// Fix: Fails to import OPML that contains empty folders
	var xmlUrl = null;
	if(aOutlineNode.hasAttribute("xmlUrl"))      xmlUrl = aOutlineNode.getAttribute("xmlUrl");
	else if(aOutlineNode.hasAttribute("xmlurl")) xmlUrl = aOutlineNode.getAttribute("xmlurl");
	else return;
	//<----- Modified by Higmmer : End -----

	if(type!="rss" && !title && xmlUrl) return;

	try { // Modified by Higmmer (inspired by Sage-Too)
		var IOService = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
		BMSVC.insertBookmark(aRssFolder, IOService.newURI(xmlUrl, null, null), -1, title);
	} catch(e) {
		logMessage(e);
	}
}

// ********** ********** Export OPML ********** **********

function exportOPML() {
	var path = txtExportFile.value;
	if (!checkFilePath(path, false)) {
		reportError(g_errorMesage);
		return false;
	}

	var opmlSource = createOpmlSource();
	opmlSource = CommonFunc.convertCharCodeFrom(opmlSource, "UTF-8");

	var tmpFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
	try {
		tmpFile.initWithPath(path);
		if(tmpFile.exists()) {
			//----- Added by Higmmer : Start ----->
			// Fix: File lost bug caused by inputting existing path to textbox manually (Bug 13389)
			if(!tmpFile.isFile()){
				reportError(strRes.getString("opml_path_invalid"));
				return false;
			}
			//<----- Added by Higmmer : End -----
			tmpFile.remove(false); // Modified by Higmmer (for the same reason as above)
		}
		tmpFile.create(tmpFile.NORMAL_FILE_TYPE, 0666);
		var stream = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
		stream.init(tmpFile, 2, 0x200, false); // open as "write only"
		stream.write(opmlSource, opmlSource.length);
		stream.flush();
		stream.close();
	} catch(e) {
		reportError(strRes.getString("opml_export_nocreate"));
		return false;
	}

	return true;
}

function createOpmlSource() {
	// Modified by Higmmer
	var rssReaderFolderID = _impl.getRootFolderId();

	var srcTemplate = '<?xml version="1.0" encoding="UTF-8"?>';
	srcTemplate += '<!--<?xml-stylesheet type="text/xsl" href="./opml2html4sage.xsl"?>-->'; // Added by Higmmer
	srcTemplate += '<opml version="1.0">';
	srcTemplate += '<head><title>Sage OPML Export</title></head>';
	srcTemplate += '<body/></opml>';

	var opmlDoc = new DOMParser().parseFromString(srcTemplate, "text/xml");
	var opmlBody = opmlDoc.getElementsByTagName("body")[0];

	createOpmlOutline(opmlDoc, opmlBody, rssReaderFolderID); // Modified by Higmmer (inspired by Sage-Too)

	xmlIndent(opmlDoc);

	var opmlSource = new XMLSerializer().serializeToString(opmlDoc);
	return opmlSource;
}

//----- Added by Higmmer : Start (inspired by Sage-Too) -----
function createOpmlOutline(opmlDoc, opmlBody, rssReaderFolderID) { // from Sage-Too 
	var rootNode = PlacesUtils.getFolderContents(rssReaderFolderID).root; // Modified by Higmmer
	var rootOutlineNode = opmlDoc.createElement("outline");
	rootOutlineNode.setAttribute("text", rootNode.title);
	opmlBody.appendChild(rootOutlineNode);

	for (var i = 0; i < rootNode.childCount; i++) {
		var node = rootNode.getChild(i);
		if (node.type == node.RESULT_TYPE_FOLDER && !_impl.nodeIsLivemarkContainer(node)) {
			procFolder(rootOutlineNode, node, opmlDoc);
		} else if (node.type == node.RESULT_TYPE_URI || _impl.nodeIsLivemarkContainer(node)) {
			var outlineNode = opmlDoc.createElement("outline");
			outlineNode.setAttribute("type", "rss");
			outlineNode.setAttribute("text", node.title);
			outlineNode.setAttribute("title", node.title);
			outlineNode.setAttribute("xmlUrl", _impl.getUrl(node)); // Modified by Higmmer
			rootOutlineNode.appendChild(outlineNode);
		}
	}
}

function procFolder(olNode, node, aOpmlDoc) { // from Sage-Too
	var folder = node.QueryInterface(Ci.nsINavHistoryContainerResultNode);
	var currentState = folder.containerOpen;

	if (!currentState) {
		folder.containerOpen = true;
	}

	var parentOutlineNode = aOpmlDoc.createElement("outline");
	parentOutlineNode.setAttribute("text", UpdateCounter._getRealTitle(folder)); // Modified by Higmmer
	olNode.appendChild(parentOutlineNode);

	for (var i = 0; i < folder.childCount; i ++) {
		var foldernode = folder.getChild(i);
		if (foldernode.type == foldernode.RESULT_TYPE_FOLDER && !_impl.nodeIsLivemarkContainer(foldernode)) {
			procFolder(parentOutlineNode, foldernode, aOpmlDoc);
		} else if (foldernode.type == foldernode.RESULT_TYPE_URI || _impl.nodeIsLivemarkContainer(foldernode)) {
			var outlineNode = aOpmlDoc.createElement("outline");
			outlineNode.setAttribute("type", "rss");
			outlineNode.setAttribute("text", foldernode.title);
			outlineNode.setAttribute("title", foldernode.title);
			outlineNode.setAttribute("xmlUrl", _impl.getUrl(foldernode)); // Modified by Higmmer
			parentOutlineNode.appendChild(outlineNode);
		}
	}
	folder.containerOpen = currentState;
}
//<----- Added by Higmmer : End -----

function xmlIndent(aDoc) {
	var treeWalker = aDoc.createTreeWalker(aDoc, NodeFilter.SHOW_ELEMENT, null, true);
	aDoc._depth = 0;
	while(treeWalker.nextNode()) {
		var cNode = treeWalker.currentNode;
		var pNode = cNode.parentNode;
		var tmpTextNode;

		if(pNode) {
			cNode._depth = pNode._depth + 1;
			if(cNode == aDoc.documentElement) continue;
			tmpTextNode = aDoc.createTextNode("\n" + getIndent(cNode._depth));
			pNode.insertBefore(tmpTextNode, cNode);
		}
		if(!cNode.nextSibling) {
			tmpTextNode = aDoc.createTextNode("\n" + getIndent(cNode._depth - 1));
			pNode.appendChild(tmpTextNode);
		}
	}
	function getIndent(aDepth) {
		// in some weird case this is NaN
		if (aDepth < 0 || isNaN(aDepth))
			return "";
		var result = new Array( aDepth );
		return result.join("\t");
	}
}

function isTextBoxEmpty(el) {
	return /^\s*$/.test(el.value);
}

function canAdvanceImport() {
	winMain.canAdvance = !isTextBoxEmpty(txtImportFile);
}

function canAdvanceExport() {
	winMain.canAdvance = !isTextBoxEmpty(txtExportFile);
}

function cancelImport() { // Added by Higmmer
	winMain.canRewind = true;
	winMain.rewind();
}

function reportError(s) {
	// This should really show an error prompt
	alert(s);
}


// Page initializers
function onPageStartShow() {
	if(!winMain) winMain = document.getElementById("winMain"); // Added by Higmmer to fix error on startup

	winMain.getButton("cancel").disabled = false;
	winMain.canAdvance = true;
}

function onPageImportShow() {
	winMain.getButton("cancel").disabled = false;
	canAdvanceImport();
}

function onPageExportShow() {
	winMain.getButton("cancel").disabled = false;
	canAdvanceExport();
}

function onPageImportingShow() { // Added by Higmmer
	winMain.getButton("cancel").disabled = false;
	winMain.canAdvance = winMain.canRewind = false;
	window.setTimeout(startImportOPML, 0);
}

function onPageImportFinishedShow() {
	document.documentElement.getButton("cancel").disabled = true;
	winMain.canRewind = false; // Added by Higmmer
}

function onPageExportFinishedShow() {
	document.documentElement.getButton("cancel").disabled = true;
	winMain.canRewind = false; // Added by Higmmer
}

